/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Case-insensitive, regular-expression pattern matching                  *
 *  routine.  See also CREP.C.                                             *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define PRODUCTION
#define INSENSITIVE

#include <stdio.h>
#include <ctype.h>
#include "prog.h"
#include "rep.h"

/* If no match, check exp-- with last_found++ */

char * pascal stristrx(char *string,struct _rep *rep)
{
  static int last_found,
             match,
             madeone;

  static char *orig_str;

  static char rtlf;

  orig_str=string;
  last_found=0;

  while (*string)
  {
    madeone=FALSE;
    rtlf=rep->type[last_found];

    while (1)
    {
      match=FALSE;

      if (rtlf & (CHAR_SOL | CHAR_EOL))
      {
        switch(*string)
        {
          case '\x00':
            if (rtlf & CHAR_SOL)
            {
              match=FALSE;
              break;
            }

            string--;
            /* fall-through! */

          case '\x0a':
          case '\x0d':
          case '\x8d':
            match=TRUE;

            while (*string=='\x0a' || *string=='\x0d' || *string=='\x8d')
              string++;

            string--;

            break;

          default:
            if (string==orig_str)
            {
              match=TRUE;
              string--;
            }
            else
              match=FALSE;
            break;
        }
      }

      switch(rtlf & (CHAR_NORM | CHAR_TABLE | CHAR_ANY))
      {
        case CHAR_NORM:
          if ((tolower(*string))==rep->c[last_found])
            match=TRUE;
          break;

        case CHAR_TABLE:
          if (rep->table[last_found][tolower(*string)])
            match=TRUE;
          break;

        case CHAR_ANY:
          match=TRUE;
          break;

        #ifndef PRODUCTION
        default:
          lputs("Bizarre error parsing compiled regular expression!");
          exit(ERROR_BIZARRE);
          break;
        #endif
      }


      if (rtlf & CHAR_ZMORE)
      {
        if (! match)
        {
          match=TRUE;

          if (last_found)
            string--;

          break;
        }

        string++;
      }
      else if (rtlf & CHAR_1MORE)
      {
        if (madeone)
        {
          if (! match)
          {
            match=TRUE;

            if (last_found)
              string--;

            break;
          }

          string++;
        }
        else
        {
          if (! match)
          {
            match=FALSE;
            break;
          }

          string++;
          madeone=TRUE;
        }
      }
      else break;
    }

    if (match)
      last_found++;
    else
    {
      if (last_found)
      {
        last_found=0;
        continue;
      }
    }

    string++;

    if (last_found==rep->max_ch)
      return(string-last_found);
  }

  /* Terminating NULL! */
  if ((rep->type[last_found] & (CHAR_SOL | CHAR_EOL)) && ++last_found==rep->max_ch)
    return(string-last_found);

  return(NULL);
}

